=== debian/changelog ===
tasmanian (8.2-2ubuntu1) resolute; urgency=medium

  * Increase variance test tolerance in testDream to avoid
    FTBFS on amd64v3, arm64, ppc64el and s390x

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 16 Jan 2026 15:02:43 +0000

tasmanian (8.2-2) unstable; urgency=medium

  * python3-tasmanian is now arch:any.
    This is needed because the harcoded path to the dlopen’d shared library is
    multiarch.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 14 Jan 2026 20:34:40 +0100

tasmanian (8.2-1) unstable; urgency=medium

  * New upstream version 8.2
  * python-multiarch.patch: new patch, needed for Python interface
  * d/control: use proper team name in Maintainer field
  * d/control: build depend on dh-sequence-fortran
    dh-sequence-fortran-mod is now deprecated.
  * Libraries are now installed in multi-arch paths
  * Drop “Priority: optional”, since it is now the default
  * Bump Standards-Version to 4.7.3
  * testsuite-i386.patch: patch marked as forwarded upstream

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 28 Dec 2025 11:13:40 +0100
