=== debian/tests/control ===
# Example taken from InterfaceCLI.md
Test-Command: tasgrid -mq -dim 4 -depth 2 -type qptotal -1d gauss-legendre -p
Depends: tasgrid

# Segfaults on riscv64 as of version 8.1-3
Tests: interface-cplusplus
Depends: libtasmanian-dev, g++
Restrictions: allow-stderr
Architecture: !riscv64

Tests: interface-fortran-2003
Depends: libtasmanian-dev, gfortran
Restrictions: allow-stderr

# Segfaults on riscv64 as of version 8.1-3
Test-Command: octave-cli --eval "addpath /usr/share/Tasmanian/matlab; tsgExample"
Depends: octave-tasmanian, octave
Restrictions: allow-stderr
Architecture: !riscv64

# Segfaults on riscv64 as of version 8.1-3
Tests: interface-python
Depends: python3-tasmanian
Restrictions: allow-stderr
Architecture: !riscv64
